/*
 * @description: 
 * @Date: 2021-07-08 19:34:32
 * @LastEditors: am
 * @LastEditTime: 2021-07-29 11:33:30
 */
import { _decorator, Component, NodePool ,RigidBody2D,Collider2D,Contact2DType,Node,UIOpacity} from 'cc';
const {ccclass, property} = _decorator;

import GameControl from "./GameControl";
/**
 * 子弹脚本，
 */

@ccclass('Bullet')
export default class Bullet extends Component {
    static instance: Bullet;
     bulletManager: any;
     public gameBullet:NodePool | undefined;
    speed: number=1000;
    rigid!: RigidBody2D;
    constructor() { super(); Bullet.instance = this;}
    onEnable(): void {
        
        this.rigid = this.node.getComponent(RigidBody2D)!;
        this.rigid.enabledContactListener = true;//开启2d碰撞

        // console.log('this.rigid.isAwake()子弹',this.rigid.isAwake());
        
        if(!this.rigid.isAwake()){
            console.log('唤醒睡觉的00000');
            this.rigid.wakeUp();
        }
        
    }
    update (dt: number) {
        // console.log('1111333');
        // this.node.setPosition(this.node.position.x,this.node.position.y+this.speed * dt);
    }
    start(){

        
        
        
        var Colliders = this.getComponent(Collider2D)!;
        if (Colliders) {
            Colliders.on(Contact2DType.BEGIN_CONTACT, this.onTriggerEnter, this);
            // console.log('开始监听子弹 ');
        }

    }
    
    async onTriggerEnter(selfCollider: any, otherCollider: { name: string; },contact: any) {
        
        // console.log('otherCollider',otherCollider.name.split('<')[0]);
        // console.log('子弹物理撞清除this.node');
        // const opacityComp = this.getComponent(UIOpacity)!;
        // opacityComp.opacity = 0;
        
        this.rigid.enabledContactListener = false;//2d碰撞
        this.rigid.sleep();
        
        // console.log('isAwake',this.rigid.isAwake());
        
        setTimeout(()=>{
            if(this.node){
                
                var Colliders = this.getComponent(Collider2D)!;
                Colliders.off(Contact2DType.BEGIN_CONTACT, function(e){
                    console.log(e,'563222222');
                }, this);

                this.node.active=false;
                GameControl.instance.createdJieshu1(this.node);
            }
        },10)
        
        // this.destroy(); //销毁会把事件去掉让下次重新用的时候麻烦
    }
    onDisable(): void {
        
        // console.log('子弹消失Colliders',Colliders);
        // console.log('子弹消失');
        
        //子弹被移除时，回收子弹到对象池，方便下次复用，减少对象创建开销
    }
}

